<template>
  <a-modal
    :width="600"
    :visible="visible"
    :confirmLoading="confirmLoading"
    @ok="handleOk"
    @cancel="handleCancel"
  >
    <template slot="title">
      <div v-if="isAdd">
        Add user
      </div>
      <div v-else>
        Update user
      </div>
    </template>
    <a-spin :spinning="confirmLoading">
      <a-form :form="form">
        <a-row>
          <a-col :span="6">
            Email
          </a-col>
          <a-col :span="18">
            <a-form-item>
              <a-input
                v-decorator="[
                  'email',
                  {
                    rules: [
                      {
                        required: true,
                        type: 'email',
                        message: 'Please enter email address.'
                      }
                    ],
                    validateTrigger: ['change', 'blur']
                  }
                ]"
                :disabled="!isAdd"
                size="large"
                type="text"
                placeholder="Emai"
              >
                <a-icon slot="prefix" :style="{ color: 'rgba(0,0,0,.25)' }" type="mail" />
              </a-input>
            </a-form-item>
          </a-col>
        </a-row>
        <a-row>
          <a-col :span="6">
            Basic info
          </a-col>
          <a-col :span="18">
            <a-form-item>
              <a-input
                v-decorator="[
                  'name',
                  {
                    rules: [{ required: true, message: 'Please enter your name.' }],
                    validateTrigger: ['change', 'blur']
                  }
                ]"
                size="large"
                type="text"
                placeholder="Name"
              >
                <a-icon slot="prefix" :style="{ color: 'rgba(0,0,0,.25)' }" type="user" />
              </a-input>
            </a-form-item>
            <a-form-item>
              <a-input
                v-decorator="[
                  'companyName',
                  {
                    rules: [{ required: true, message: 'Please enter your name.' }],
                    validateTrigger: ['change', 'blur']
                  }
                ]"
                size="large"
                type="text"
                placeholder="Company name"
              >
                <a-icon slot="prefix" :style="{ color: 'rgba(0,0,0,.25)' }" type="user" />
              </a-input>
            </a-form-item>
            <a-form-item>
              <a-input
                v-decorator="[
                  'companyNameKana',
                  {
                    rules: [{ required: true, message: 'Please enter your name.' }],
                    validateTrigger: ['change', 'blur']
                  }
                ]"
                size="large"
                type="text"
                placeholder="Company name (Kana)"
              >
                <a-icon slot="prefix" :style="{ color: 'rgba(0,0,0,.25)' }" type="user" />
              </a-input>
            </a-form-item>
          </a-col>
        </a-row>
      </a-form>
    </a-spin>
  </a-modal>
</template>

<script>
import { recruiterApi } from '@/api'

export default {
  name: 'UserModal',
  data () {
    return {
      labelCol: {
        xs: { span: 5 },
        sm: { span: 5 }
      },
      wrapperCol: {
        xs: { span: 16 },
        sm: { span: 16 }
      },
      visible: false,
      confirmLoading: false,
      isAdd: true,
      record: null
    }
  },
  beforeCreate () {
    this.form = this.$form.createForm(this)
  },
  methods: {
    add () {
      this.isAdd = true
      this.visible = true
      this.record = null
      this.$nextTick(() => {
        this.form.setFieldsValue({
          name: null,
          email: null
        })
      })
    },
    edit (record) {
      this.isAdd = false
      this.visible = true
      this.record = record
      this.$nextTick(() => {
        this.form.setFieldsValue({ ...record })
      })
    },
    close () {
      this.$emit('close')
      this.visible = false
    },
    handleOk () {
      const _this = this
      this.form.validateFields((err, values) => {
        if (!err) {
          _this.confirmLoading = true
          const data = {
            userName: values.email,
            email: values.email,
            name: values.name
          }
          recruiterApi
            .createUser(data, _this.isAdd)
            .then((user) => {
              // Do something
              const message = _this.isAdd ? 'Create user successful' : 'Update user successful'
              _this.$message.success(message)
              _this.$emit('ok', user)
            })
            .catch((err) => {
              // Do something
              console.log(err)
              _this.$message.error(err.message, 3)
            })
            .finally(() => {
              _this.confirmLoading = false
              _this.close()
            })
        }
      })
    },
    handleCancel () {
      this.close()
    }
  }
}
</script>
